<?php
/**
 * WPLMS PARENT USER Init
 *
 * @author 		VibeThemes
 * @category 	Admin
 * @package 	Wplms-Course-Invite-Application/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


class Wplms_course_invite_app_Init{

	public static $instance;
    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Wplms_course_invite_app_Init();
        return self::$instance;
        
    }

	private function __construct(){

		add_action('wplms_the_course_button',array($this,'change_apply_to_woo_pricing'),10,2);

		add_action('bp_course_order_complete_item_subscribe_user',array($this,'check_if_applied_course_check'),10,5);

		add_filter('wplms_course_creation_tabs',array($this,'add_in_front_end'));

	}


	function change_apply_to_woo_pricing($course_id,$user_id){
		$product_id=get_post_meta($course_id,'vibe_product',true);
		$product_taken = wc_customer_bought_product('',$user_id,$product_id);
		if(!$product_taken){
			$filters = bp_course_filters::init();
			remove_filter('wplms_take_this_course_button_label',array($filters,'apply_course_button_label'),10,2);
			remove_filter('wplms_private_course_button_label',array($filters,'apply_course_button_label'),10,2);
			remove_filter('wplms_course_product_id',array($filters,'apply_course_button_link'),10,2);
			remove_filter('wplms_private_course_button',array($filters,'apply_course_button_link'),10,2);
			remove_filter('wplms_course_details_widget',array($filters,'hide_price'),10,2);
		}
	}

	function check_if_applied_course_check($bool,$item_id,$product_id,$item,$order_id){
		$courses = get_post_meta($product_id,'vibe_courses',true);
		foreach ($courses as $key => $course) {
		//check course settings
			$set = get_post_meta($course,'requires_purchase_before_apply',true);
		
			if(!empty($set) && function_exists('vibe_validate') && vibe_validate($set)){
				return false;
			}
		}
		return $bool;
	}

	function add_in_front_end($settings){
        $fields = $settings['course_pricing']['fields'];
	    $arr=array(
	             array(
	                'label'=> __('Requires Purchase Before Apply','wplms-course-invite-application' ),
	                'text'=>__('Requires Purchase Before Apply ','wplms-course-invite-application' ),
	                'type'=> 'switch',
	                'options'  => array('H'=>__('DISABLE','wplms-course-invite-application' ),'S'=>__('ENABLE','wplms-course-invite-application' )),
	                'style'=>'',
	                'id' => 'requires_purchase_before_apply',
	                'from'=> 'meta',
	                'default'=>'H',
	                'desc'=> __('Requires Purchase Before Apply, If it is set to no then course will work as normal. There will be no need to purchase course for apply. ','wplms-course-invite-application' )
	                ),);


	    array_splice($fields, (count($fields)-1), 0,$arr );
	    $settings['course_pricing']['fields'] = $fields;  
	  return $settings;
	}

}
Wplms_course_invite_app_Init::init();